=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2011-03-16 11:40:05 +0000
+++ loggerhead/apps/branch.py	2011-06-28 13:13:05 +0000
@@ -136,7 +136,7 @@
     def public_branch_url(self):
         return self.branch.get_config().get_user_option('public_branch')
 
-    def app(self, environ, start_response):
+    def lookup_app(self, environ):
         # Check again if the branch is blocked from being served, this is
         # mostly for tests. It's already checked in apps/transport.py
         if self.branch.get_config().get_user_option('http_serve') == 'False':
@@ -163,14 +163,17 @@
             raise httpexceptions.HTTPMovedPermanently(
                 self.absolute_url('/changes'))
         if path == 'static':
-            return static_app(environ, start_response)
+            return static_app
         cls = self.controllers_dict.get(path)
         if cls is None:
             raise httpexceptions.HTTPNotFound()
+        return cls(self, self.get_history)
+
+    def app(self, environ, start_response):
         self.branch.lock_read()
         try:
             try:
-                c = cls(self, self.get_history)
+                c = self.lookup_app(environ)
                 return c(environ, start_response)
             except:
                 environ['exc_info'] = sys.exc_info()

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2011-03-16 11:40:05 +0000
+++ loggerhead/controllers/__init__.py	2011-06-28 13:13:05 +0000
@@ -67,8 +67,7 @@
         self.__history = self._history_callable()
         return self.__history
 
-    def __call__(self, environ, start_response):
-        z = time.time()
+    def parse_args(self, environ):
         kwargs = dict(parse_querystring(environ))
         util.set_context(kwargs)
         args = []
@@ -82,17 +81,23 @@
         if len(args) > 1:
             path = unicode('/'.join(args[1:]), 'utf-8')
         self.args = args
+        self.kwargs = kwargs
+        return path
 
-        vals = {
+    def add_template_values(self, values):
+        values.update({
             'static_url': self._branch.static_url,
             'branch': self._branch,
             'util': util,
             'url': self._branch.context_url,
-        }
-        vals.update(templatefunctions)
+        })
+        values.update(templatefunctions)
+
+    def __call__(self, environ, start_response):
+        z = time.time()
+        path = self.parse_args(environ)
         headers = {}
-
-        vals.update(self.get_values(path, kwargs, headers))
+        values = self.get_values(path, self.kwargs, headers)
 
         self.log.info('Getting information for %s: %.3f secs' % (
             self.__class__.__name__, time.time() - z))
@@ -102,10 +107,11 @@
         if environ.get('REQUEST_METHOD') == 'HEAD':
             # No content for a HEAD request
             return []
+        z = time.time()
+        w = BufferingWriter(writer, 8192)
+        self.add_template_values(values)
         template = load_template(self.template_path)
-        z = time.time()
-        w = BufferingWriter(writer, 8192)
-        template.expand_into(w, **vals)
+        template.expand_into(w, **values)
         w.flush()
         self.log.info(
             'Rendering %s: %.3f secs, %s bytes' % (

